Index: trunk/sources/HeuristicLab.Permutation/3.3/PositionBasedCrossover.cs
===================================================================
--- trunk/sources/HeuristicLab.Permutation/3.3/PositionBasedCrossover.cs	(revision 2852)
+++ trunk/sources/HeuristicLab.Permutation/3.3/PositionBasedCrossover.cs	(revision 2854)
@@ -1,5 +1,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -25,4 +25,5 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
 namespace HeuristicLab.Permutation {
@@ -30,19 +31,23 @@
   /// Performs a cross over permutation between two permutation arrays based on randomly chosen positions.
   /// </summary>
-  public class PositionBasedCrossover : PermutationCrossoverBase {
-    /// <inheritdoc select="summary"/>
-    public override string Description {
-      get { return @"TODO\r\nOperator description still missing ..."; }
-    }
-
+  /// <remarks>
+  /// Implemented as described in Syswerda, G. (1991). Schedule Optimization Using Genetic Algorithms,
+  /// in Davis, L. (Ed.) Handbook of Genetic Algorithms, Van Nostrand Reinhold, New York, pp 332-349.
+  /// </remarks>
+  [Item("PositionBasedCrossover", "An operator which performs the position based crossover on two permutations.")]
+  [EmptyStorableClass]
+  [Creatable("Test")]
+  public class PositionBasedCrossover : PermutationCrossover {
     /// <summary>
     /// Performs a cross over permutation of <paramref name="parent1"/> and <paramref name="parent2"/>
     /// based on randomly chosen positions to define which position to take from where.
     /// </summary>
+    /// <exception cref="ArgumentException">Thrown when <paramref name="parent1"/> and <paramref name="parent2"/> are not of equal length.</exception>
     /// <param name="random">The random number generator.</param>
-    /// <param name="parent1">The permutation array of parent 1.</param>
-    /// <param name="parent2">The permutation array of parent 2.</param>
-    /// <returns>The created cross over permutation as int array.</returns>
-    public static int[] Apply(IRandom random, int[] parent1, int[] parent2) {
+    /// <param name="parent1">First parent</param>
+    /// <param name="parent2">Second Parent</param>
+    /// <returns>Child</returns>
+    public static Permutation Apply(IRandom random, Permutation parent1, Permutation parent2) {
+      if (parent1.Length != parent2.Length) throw new ArgumentException("PositionBasedCrossover: The parent permutations are of unequal length.");
       int length = parent1.Length;
       int[] result = new int[length];
@@ -74,5 +79,6 @@
         }
       }
-      return result;
+
+      return new Permutation(result);
     }
 
@@ -81,9 +87,8 @@
     /// </summary>
     /// <exception cref="InvalidOperationException">Thrown if there are not exactly two parents.</exception>
-    /// <param name="scope">The current scope.</param>
     /// <param name="random">A random number generator.</param>
     /// <param name="parents">An array containing the two permutations that should be crossed.</param>
     /// <returns>The newly created permutation, resulting from the crossover operation.</returns>
-    protected override int[] Cross(IScope scope, IRandom random, int[][] parents) {
+    protected override Permutation Cross(IRandom random, ItemArray<Permutation> parents) {
       if (parents.Length != 2) throw new InvalidOperationException("ERROR in PositionBasedCrossover: The number of parents is not equal to 2");
       return Apply(random, parents[0], parents[1]);
Index: trunk/sources/HeuristicLab.Permutation/3.3/ScrambleManipulator.cs
===================================================================
--- trunk/sources/HeuristicLab.Permutation/3.3/ScrambleManipulator.cs	(revision 2852)
+++ trunk/sources/HeuristicLab.Permutation/3.3/ScrambleManipulator.cs	(revision 2854)
@@ -1,5 +1,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -24,4 +24,5 @@
 using System.Text;
 using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
 namespace HeuristicLab.Permutation {
@@ -29,10 +30,12 @@
   /// Manipulates a permutation array by randomly scrambling the elements in a randomly chosen interval.
   /// </summary>
-  public class ScrambleManipulator : PermutationManipulatorBase {
-    /// <inheritdoc select="summary"/>
-    public override string Description {
-      get { return @"TODO\r\nOperator description still missing ..."; }
-    }
-
+  /// <remarks>
+  /// Implemented as described in Syswerda, G. (1991). Schedule Optimization Using Genetic Algorithms,
+  /// in Davis, L. (Ed.) Handbook of Genetic Algorithms, Van Nostrand Reinhold, New York, pp 332-349.
+  /// </remarks>
+  [Item("ScrambleManipulator", "An operator which manipulates a permutation array by randomly scrambling the elements in a randomly chosen interval.")]
+  [EmptyStorableClass]
+  [Creatable("Test")]
+  public class ScrambleManipulator : PermutationManipulator {
     /// <summary>
     /// Mixes the elements of the given <paramref name="permutation"/> randomly 
@@ -40,14 +43,14 @@
     /// </summary>
     /// <param name="random">The random number generator.</param>
-    /// <param name="permutation">The permutation array to manipulate.</param>
-    /// <returns>The new permuation array with the manipulated data.</returns>
-    public static int[] Apply(IRandom random, int[] permutation) {
-      int[] result = (int[])permutation.Clone();
+    /// <param name="permutation">The permutation to manipulate.</param>
+    public static void Apply(IRandom random, Permutation permutation) {
+      Permutation original = (Permutation)permutation.Clone();
+
       int breakPoint1, breakPoint2;
       int[] scrambledIndices, remainingIndices, temp;
       int selectedIndex, index;
 
-      breakPoint1 = random.Next(permutation.Length - 1);
-      breakPoint2 = random.Next(breakPoint1 + 1, permutation.Length);
+      breakPoint1 = random.Next(original.Length - 1);
+      breakPoint2 = random.Next(breakPoint1 + 1, original.Length);
 
       scrambledIndices = new int[breakPoint2 - breakPoint1 + 1];
@@ -73,7 +76,6 @@
 
       for (int i = 0; i <= (breakPoint2 - breakPoint1); i++) {  // scramble permutation between breakpoints
-        result[breakPoint1 + i] = permutation[breakPoint1 + scrambledIndices[i]];
+        permutation[breakPoint1 + i] = original[breakPoint1 + scrambledIndices[i]];
       }
-      return result;
     }
 
@@ -83,10 +85,8 @@
     /// </summary>
     /// <remarks>Calls <see cref="Apply"/>.</remarks>
-    /// <param name="scope">The current scope.</param>
-    /// <param name="random">The random number generator.</param>
-    /// <param name="permutation">The permutation array to manipulate.</param>
-    /// <returns>The new permuation array with the manipulated data.</returns>
-    protected override int[] Manipulate(IScope scope, IRandom random, int[] permutation) {
-      return Apply(random, permutation);
+    /// <param name="random">A random number generator.</param>
+    /// <param name="permutation">The permutation to manipulate.</param>
+    protected override void Manipulate(IRandom random, Permutation permutation) {
+      Apply(random, permutation);
     }
   }
Index: trunk/sources/HeuristicLab.Permutation/3.3/Swap2Manipulator.cs
===================================================================
--- trunk/sources/HeuristicLab.Permutation/3.3/Swap2Manipulator.cs	(revision 2852)
+++ trunk/sources/HeuristicLab.Permutation/3.3/Swap2Manipulator.cs	(revision 2854)
@@ -1,5 +1,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -24,4 +24,5 @@
 using System.Text;
 using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
 namespace HeuristicLab.Permutation {
@@ -29,28 +30,25 @@
   /// Manipulates a permutation array by swapping to randomly chosen elements.
   /// </summary>
-  public class Swap2Manipulator : PermutationManipulatorBase {
-    /// <inheritdoc select="summary"/>
-    public override string Description {
-      get { return @"TODO\r\nOperator description still missing ..."; }
-    }
-
+  ///   /// <remarks>
+  /// It is implemented as described in Eiben, A.E. and Smith, J.E. 2003. Introduction to Evolutionary Computation. Natural Computing Series, Springer-Verlag Berlin Heidelberg.<br />
+  /// </remarks>
+  [Item("Swap2Manipulator", "An operator which manipulates a permutation array by swapping to randomly chosen elements.")]
+  [EmptyStorableClass]
+  [Creatable("Test")]
+  public class Swap2Manipulator : PermutationManipulator {
     /// <summary>
-    /// Swaps two randomly chosen elements in the given <paramref name="permutation"/> array.
+    /// Swaps two randomly chosen elements in the given <paramref name="permutation"/> permutation.
     /// </summary>
     /// <param name="random">The random number generator.</param>
-    /// <param name="permutation">The permutation array to manipulate.</param>
-    /// <returns>The new permuation array with the manipulated data.</returns>
-    public static int[] Apply(IRandom random, int[] permutation) {
-      int[] result = (int[])permutation.Clone();
+    /// <param name="permutation">The permutation to manipulate.</param>
+    public static void Apply(IRandom random, Permutation permutation) {
       int index1, index2, temp;
 
-      index1 = random.Next(result.Length);
-      index2 = random.Next(result.Length);
+      index1 = random.Next(permutation.Length);
+      index2 = random.Next(permutation.Length);
 
-      temp = result[index1];
-      result[index1] = result[index2];
-      result[index2] = temp;
-
-      return result;
+      temp = permutation[index1];
+      permutation[index1] = permutation[index2];
+      permutation[index2] = temp;
     }
 
@@ -59,10 +57,8 @@
     /// </summary>
     /// <remarks>Calls <see cref="Apply"/>.</remarks>
-    /// <param name="scope">The current scope.</param>
-    /// <param name="random">The random number generator.</param>
-    /// <param name="permutation">The permutation array to manipulate.</param>
-    /// <returns>The new permuation array with the manipulated data.</returns>
-    protected override int[] Manipulate(IScope scope, IRandom random, int[] permutation) {
-      return Apply(random, permutation);
+    /// <param name="random">A random number generator.</param>
+    /// <param name="permutation">The permutation to manipulate.</param>
+    protected override void Manipulate(IRandom random, Permutation permutation) {
+      Apply(random, permutation);
     }
   }
Index: trunk/sources/HeuristicLab.Permutation/3.3/Swap3Manipulator.cs
===================================================================
--- trunk/sources/HeuristicLab.Permutation/3.3/Swap3Manipulator.cs	(revision 2852)
+++ trunk/sources/HeuristicLab.Permutation/3.3/Swap3Manipulator.cs	(revision 2854)
@@ -1,5 +1,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -24,4 +24,5 @@
 using System.Text;
 using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
 namespace HeuristicLab.Permutation {
@@ -29,44 +30,39 @@
   /// Manipulates a permutation array by swaping three randomly chosen elements.
   /// </summary>
-  public class Swap3Manipulator : PermutationManipulatorBase {
-    /// <inheritdoc select="summary"/>
-    public override string Description {
-      get { return @"TODO\r\nOperator description still missing ..."; }
-    }
-
+  [Item("Swap3Manipulator", "An operator which manipulates a permutation array by swaping three randomly chosen elements.")]
+  [EmptyStorableClass]
+  [Creatable("Test")]
+  public class Swap3Manipulator : PermutationManipulator {
     /// <summary>
     /// Swaps three randomly chosen elements of the given <paramref name="permutation"/> array.
     /// </summary>
     /// <param name="random">The random number generator.</param>
-    /// <param name="permutation">The permutation array to manipulate.</param>
-    /// <returns>The new permuation array with the manipulated data.</returns>
-    public static int[] Apply(IRandom random, int[] permutation) {
-      int[] result = (int[])permutation.Clone();
+    /// <param name="permutation">The permutation to manipulate.</param>
+    public static void Apply(IRandom random, Permutation permutation) {
       int index1, index2, index3, temp;
 
-      index1 = random.Next(result.Length);
-      index2 = random.Next(result.Length);
-      index3 = random.Next(result.Length);
+      index1 = random.Next(permutation.Length);
+      index2 = random.Next(permutation.Length);
+      index3 = random.Next(permutation.Length);
 
       if (random.NextDouble() < 0.5) {
         // swap edges 1 and 2
-        temp = result[index1];
-        result[index1] = result[index2];
-        result[index2] = temp;
+        temp = permutation[index1];
+        permutation[index1] = permutation[index2];
+        permutation[index2] = temp;
         // swap edges 2 and 3
-        temp = result[index2];
-        result[index2] = result[index3];
-        result[index3] = temp;
+        temp = permutation[index2];
+        permutation[index2] = permutation[index3];
+        permutation[index3] = temp;
       } else {
         // swap edges 1 and 3
-        temp = result[index1];
-        result[index1] = result[index3];
-        result[index3] = temp;
+        temp = permutation[index1];
+        permutation[index1] = permutation[index3];
+        permutation[index3] = temp;
         // swap edges 2 and 3
-        temp = result[index2];
-        result[index2] = result[index3];
-        result[index3] = temp;
+        temp = permutation[index2];
+        permutation[index2] = permutation[index3];
+        permutation[index3] = temp;
       }
-      return result;
     }
 
@@ -75,10 +71,8 @@
     /// </summary>
     /// <remarks>Calls <see cref="Apply"/>.</remarks>
-    /// <param name="scope">The current scope.</param>
-    /// <param name="random">The random number generator.</param>
-    /// <param name="permutation">The permutation array to manipulate.</param>
-    /// <returns>The new permuation array with the manipulated data.</returns>
-    protected override int[] Manipulate(IScope scope, IRandom random, int[] permutation) {
-      return Apply(random, permutation);
+    /// <param name="random">A random number generator.</param>
+    /// <param name="permutation">The permutation to manipulate.</param>
+    protected override void Manipulate(IRandom random, Permutation permutation) {
+      Apply(random, permutation);
     }
   }
Index: trunk/sources/HeuristicLab.Permutation/3.3/Tests/AbsolutePositionTopologicalCrossoverTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Permutation/3.3/Tests/AbsolutePositionTopologicalCrossoverTest.cs	(revision 2854)
+++ trunk/sources/HeuristicLab.Permutation/3.3/Tests/AbsolutePositionTopologicalCrossoverTest.cs	(revision 2854)
@@ -0,0 +1,142 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Permutation;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Permutation.Tests
+{
+    
+    
+    /// <summary>
+    ///This is a test class for AbsolutePositionTopologicalCrossoverTest and is intended
+    ///to contain all AbsolutePositionTopologicalCrossoverTest Unit Tests
+    ///</summary>
+  [TestClass()]
+  public class AbsolutePositionTopologicalCrossoverTest {
+
+
+    private TestContext testContextInstance;
+
+    /// <summary>
+    ///Gets or sets the test context which provides
+    ///information about and functionality for the current test run.
+    ///</summary>
+    public TestContext TestContext {
+      get {
+        return testContextInstance;
+      }
+      set {
+        testContextInstance = value;
+      }
+    }
+
+    #region Additional test attributes
+    // 
+    //You can use the following additional attributes as you write your tests:
+    //
+    //Use ClassInitialize to run code before running the first test in the class
+    //[ClassInitialize()]
+    //public static void MyClassInitialize(TestContext testContext)
+    //{
+    //}
+    //
+    //Use ClassCleanup to run code after all tests in a class have run
+    //[ClassCleanup()]
+    //public static void MyClassCleanup()
+    //{
+    //}
+    //
+    //Use TestInitialize to run code before running each test
+    //[TestInitialize()]
+    //public void MyTestInitialize()
+    //{
+    //}
+    //
+    //Use TestCleanup to run code after each test has run
+    //[TestCleanup()]
+    //public void MyTestCleanup()
+    //{
+    //}
+    //
+    #endregion
+
+
+    /// <summary>
+    ///A test for Cross
+    ///</summary>
+    [TestMethod()]
+    [DeploymentItem("HeuristicLab.Permutation-3.3.dll")]
+    public void AbsolutePositionTopologicalCrossoverCrossTest() {
+      TestRandom random = new TestRandom();
+      AbsolutePositionTopologicalCrossover_Accessor target = 
+        new AbsolutePositionTopologicalCrossover_Accessor(new PrivateObject(typeof(AbsolutePositionTopologicalCrossover)));
+      // perform a test with more than two parents
+      random.Reset();
+      bool exceptionFired = false;
+      try {
+        target.Cross(random, new ItemArray<Permutation>(new Permutation[] { 
+          new Permutation(4), new Permutation(4), new Permutation(4)}));
+      } catch (System.InvalidOperationException) {
+        exceptionFired = true;
+      }
+      Assert.IsTrue(exceptionFired);
+    }
+
+    /// <summary>
+    ///A test for Apply
+    ///</summary>
+    [TestMethod()]
+    public void AbsolutePositionTopologicalCrossoverApplyTest() {
+      TestRandom random = new TestRandom();
+      Permutation parent1, parent2, expected, actual;
+      random.Reset();
+      parent1 = new Permutation(new int[] { 0, 1, 2, 3, 4, 5, 6, 7 });
+      Assert.IsTrue(parent1.Validate());
+      parent2 = new Permutation(new int[] { 1, 3, 5, 7, 6, 4, 2, 0 });
+      Assert.IsTrue(parent2.Validate());
+      expected = new Permutation(new int[] { 0, 1, 3, 2, 5, 7, 4, 6 });
+      Assert.IsTrue(expected.Validate());
+      actual = AbsolutePositionTopologicalCrossover.Apply(random, parent1, parent2);
+      Assert.IsTrue(actual.Validate());
+      Assert.IsTrue(Auxiliary.PermutationIsEqualByPosition(expected, actual));
+
+      // perform a test when the two permutations are of unequal length
+      random.Reset();
+      bool exceptionFired = false;
+      try {
+        AbsolutePositionTopologicalCrossover.Apply(random, new Permutation(8), new Permutation(6));
+      } catch (System.ArgumentException) {
+        exceptionFired = true;
+      }
+      Assert.IsTrue(exceptionFired);
+    }
+
+    /// <summary>
+    ///A test for AbsolutePositionTopologicalCrossover Constructor
+    ///</summary>
+    [TestMethod()]
+    public void AbsolutePositionTopologicalCrossoverConstructorTest() {
+      AbsolutePositionTopologicalCrossover target = new AbsolutePositionTopologicalCrossover();
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Permutation/3.3/Tests/Auxiliary.cs
===================================================================
--- trunk/sources/HeuristicLab.Permutation/3.3/Tests/Auxiliary.cs	(revision 2852)
+++ trunk/sources/HeuristicLab.Permutation/3.3/Tests/Auxiliary.cs	(revision 2854)
@@ -1,3 +1,24 @@
-﻿using System;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
 using System.Collections.Generic;
 using System.Linq;
Index: trunk/sources/HeuristicLab.Permutation/3.3/Tests/CosaCrossoverTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Permutation/3.3/Tests/CosaCrossoverTest.cs	(revision 2854)
+++ trunk/sources/HeuristicLab.Permutation/3.3/Tests/CosaCrossoverTest.cs	(revision 2854)
@@ -0,0 +1,143 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Permutation;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Permutation.Tests
+{
+    
+    
+    /// <summary>
+    ///This is a test class for CosaCrossoverTest and is intended
+    ///to contain all CosaCrossoverTest Unit Tests
+    ///</summary>
+  [TestClass()]
+  public class CosaCrossoverTest {
+
+
+    private TestContext testContextInstance;
+
+    /// <summary>
+    ///Gets or sets the test context which provides
+    ///information about and functionality for the current test run.
+    ///</summary>
+    public TestContext TestContext {
+      get {
+        return testContextInstance;
+      }
+      set {
+        testContextInstance = value;
+      }
+    }
+
+    #region Additional test attributes
+    // 
+    //You can use the following additional attributes as you write your tests:
+    //
+    //Use ClassInitialize to run code before running the first test in the class
+    //[ClassInitialize()]
+    //public static void MyClassInitialize(TestContext testContext)
+    //{
+    //}
+    //
+    //Use ClassCleanup to run code after all tests in a class have run
+    //[ClassCleanup()]
+    //public static void MyClassCleanup()
+    //{
+    //}
+    //
+    //Use TestInitialize to run code before running each test
+    //[TestInitialize()]
+    //public void MyTestInitialize()
+    //{
+    //}
+    //
+    //Use TestCleanup to run code after each test has run
+    //[TestCleanup()]
+    //public void MyTestCleanup()
+    //{
+    //}
+    //
+    #endregion
+
+
+    /// <summary>
+    ///A test for Cross
+    ///</summary>
+    [TestMethod()]
+    [DeploymentItem("HeuristicLab.Permutation-3.3.dll")]
+    public void CosaCrossoverCrossTest() {
+      TestRandom random = new TestRandom();
+      CosaCrossover_Accessor target = 
+        new CosaCrossover_Accessor(new PrivateObject(typeof(CosaCrossover)));
+      // perform a test with more than two parents
+      random.Reset();
+      bool exceptionFired = false;
+      try {
+        target.Cross(random, new ItemArray<Permutation>(new Permutation[] { 
+          new Permutation(4), new Permutation(4), new Permutation(4)}));
+      } catch (System.InvalidOperationException) {
+        exceptionFired = true;
+      }
+      Assert.IsTrue(exceptionFired);
+    }
+
+    /// <summary>
+    ///A test for Apply
+    ///</summary>
+    [TestMethod()]
+    public void CosaCrossoverApplyTest() {
+      TestRandom random = new TestRandom();
+      Permutation parent1, parent2, expected, actual;
+      random.Reset();
+      random.IntNumbers = new int[] { 4 };
+      parent1 = new Permutation(new int[] { 0, 1, 2, 3, 4, 5, 6, 7 });
+      Assert.IsTrue(parent1.Validate());
+      parent2 = new Permutation(new int[] { 1, 3, 5, 7, 6, 4, 2, 0 });
+      Assert.IsTrue(parent2.Validate());
+      expected = new Permutation(new int[] { 6, 5, 7, 0, 1, 2, 3, 4 });
+      Assert.IsTrue(expected.Validate());
+      actual = CosaCrossover.Apply(random, parent1, parent2);
+      Assert.IsTrue(actual.Validate());
+      Assert.IsTrue(Auxiliary.PermutationIsEqualByPosition(expected, actual));
+
+      // perform a test when the two permutations are of unequal length
+      random.Reset();
+      bool exceptionFired = false;
+      try {
+        CosaCrossover.Apply(random, new Permutation(8), new Permutation(6));
+      } catch (System.ArgumentException) {
+        exceptionFired = true;
+      }
+      Assert.IsTrue(exceptionFired);
+    }
+
+    /// <summary>
+    ///A test for CosaCrossover Constructor
+    ///</summary>
+    [TestMethod()]
+    public void CosaCrossoverConstructorTest() {
+      CosaCrossover target = new CosaCrossover();
+    }
+  }
+}
